--- regress/cert-file.sh	Mon Mar 20 03:39:27 2017
+++ regress/cert-file.sh	Mon Jul 31 00:26:53 2017
@@ -46,7 +46,7 @@
 trace 'try with identity files'
 opts="-F $OBJ/ssh_proxy -oIdentitiesOnly=yes"
 opts2="$opts -i $OBJ/user_key1 -i $OBJ/user_key2"
-echo "cert-authority $(cat $OBJ/user_ca_key1.pub)" > $OBJ/authorized_keys_$USER
+echo "cert-authority `cat $OBJ/user_ca_key1.pub`" > $OBJ/authorized_keys_$USER
 
 # Make a clean config that doesn't have any pre-added identities.
 cat $OBJ/ssh_proxy | grep -v IdentityFile > $OBJ/no_identity_config
--- regress/cert-userkey.sh	Mon Mar 20 03:39:27 2017
+++ regress/cert-userkey.sh	Mon Jul 31 00:26:53 2017
@@ -17,7 +17,7 @@
 	case $ktype in
 	rsa-sha2-*) ;;
 	# subshell because some seds will add a newline
-	*) n=$(echo $1 | sed 's/^dsa/ssh-dss/;s/^rsa/ssh-rsa/;s/^ed/ssh-ed/') ;;
+	*) n=`echo $1 | sed 's/^dsa/ssh-dss/;s/^rsa/ssh-rsa/;s/^ed/ssh-ed/'` ;;
 	esac
 	echo "$n*,ssh-rsa*,ssh-ed25519*"
 }
@@ -45,7 +45,7 @@
 
 # Test explicitly-specified principals
 for ktype in $EXTRA_TYPES $PLAIN_TYPES ; do
-	t=$(kname $ktype)
+	t=`kname $ktype`
 	for privsep in yes no ; do
 		_prefix="${ktype} privsep $privsep"
 
@@ -182,7 +182,7 @@
 	fi
 
 	for ktype in $PLAIN_TYPES ; do
-		t=$(kname $ktype)
+		t=`kname $ktype`
 		for privsep in yes no ; do
 			_prefix="${ktype} privsep $privsep $auth"
 			# Simple connect
@@ -371,7 +371,7 @@
 # Wrong certificate
 cat $OBJ/sshd_proxy_bak > $OBJ/sshd_proxy
 for ktype in $PLAIN_TYPES ; do
-	t=$(kname $ktype)
+	t=`kname $ktype`
 	# Self-sign
 	${SSHKEYGEN} -q -s $OBJ/cert_user_key_${ktype} -I \
 	    "regress user key for $USER" \
--- regress/integrity.sh	Mon Mar 20 03:39:27 2017
+++ regress/integrity.sh	Mon Jul 31 00:26:53 2017
@@ -53,8 +53,8 @@
 			fail "ssh -m $m succeeds with bit-flip at $off"
 		fi
 		ecnt=`expr $ecnt + 1`
-		out=$(egrep -v "^debug" $TEST_SSH_LOGFILE | tail -2 | \
-		     tr -s '\r\n' '.')
+		out=`egrep -v "^debug" $TEST_SSH_LOGFILE | tail -2 | \
+		     tr -s '\r\n' '.'`
 		case "$out" in
 		Bad?packet*)	elen=`expr $elen + 1`; skip=3;;
 		Corrupted?MAC* | *message?authentication?code?incorrect*)
--- regress/multiplex.sh	Mon Mar 20 03:39:27 2017
+++ regress/multiplex.sh	Mon Jul 31 00:26:53 2017
@@ -77,10 +77,10 @@
 rm -f ${COPY}
 verbose "test $tid: forward"
 trace "forward over TCP/IP and check result"
-$NC -N -l 127.0.0.1 $((${PORT} + 1)) < ${DATA} > /dev/null &
+$NC -N -l 127.0.0.1 `expr ${PORT} + 1` < ${DATA} > /dev/null &
 netcat_pid=$!
-${SSH} -F $OBJ/ssh_config -S $CTL -Oforward -L127.0.0.1:$((${PORT} + 2)):127.0.0.1:$((${PORT} + 1)) otherhost >>$TEST_SSH_LOGFILE 2>&1
-$NC 127.0.0.1 $((${PORT} + 2)) < /dev/null > ${COPY}
+${SSH} -F $OBJ/ssh_config -S $CTL -Oforward -L127.0.0.1:`expr ${PORT} + 2`:127.0.0.1:`expr ${PORT} + 1` otherhost >>$TEST_SSH_LOGFILE 2>&1
+$NC 127.0.0.1 `expr ${PORT} + 2` < /dev/null > ${COPY}
 cmp ${DATA} ${COPY}		|| fail "ssh: corrupted copy of ${DATA}"
 kill $netcat_pid 2>/dev/null
 rm -f ${COPY} $OBJ/unix-[123].fwd
@@ -145,7 +145,7 @@
      || fail "connect to local forward path failed"
 ${SSH} -F $OBJ/ssh_config -S $CTL -Ocancel -L $OBJ/unix-1.fwd:localhost:$PORT otherhost \
      || fail "cancel local forward failed"
-N=$(echo "xyzzy" | $NC -U $OBJ/unix-1.fwd 2>&1 | grep "xyzzy" | wc -l)
+N=`echo "xyzzy" | $NC -U $OBJ/unix-1.fwd 2>&1 | grep "xyzzy" | wc -l`
 test ${N} -eq 0 || fail "local forward path still listening"
 rm -f $OBJ/unix-1.fwd
 
@@ -156,7 +156,7 @@
      || fail "connect to remote forwarded path failed"
 ${SSH} -F $OBJ/ssh_config -S $CTL -Ocancel -R $OBJ/unix-1.fwd:localhost:$PORT otherhost \
      || fail "cancel remote forward failed"
-N=$(echo "xyzzy" | $NC -U $OBJ/unix-1.fwd 2>&1 | grep "xyzzy" | wc -l)
+N=`echo "xyzzy" | $NC -U $OBJ/unix-1.fwd 2>&1 | grep "xyzzy" | wc -l`
 test ${N} -eq 0 || fail "remote forward path still listening"
 rm -f $OBJ/unix-1.fwd
 
--- regress/test-exec.sh	Mon Mar 20 03:39:27 2017
+++ regress/test-exec.sh	Mon Jul 31 00:26:53 2017
@@ -73,7 +73,7 @@
 SSHKEYGEN=ssh-keygen
 SSHKEYSCAN=ssh-keyscan
 SFTP=sftp
-SFTPSERVER=/usr/libexec/openssh/sftp-server
+SFTPSERVER=sftp-server
 SCP=scp
 
 # Interop testing